SystemOrganization addCategory: #BugFinderExample!

Error subclass: #ElementTooBig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BugFinderExample'!

Error subclass: #EmptyBox
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BugFinderExample'!

Object subclass: #Box
	instanceVariableNames: 'capacity elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BugFinderExample'!

!Box methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/14/2011 18:17'!
add: aBoxElement
	(aBoxElement size > capacity)
		ifTrue: [ ElementTooBig signal: 'Element does not fit into box' ]
		ifFalse: [
			elements add: aBoxElement.
			capacity := capacity - (aBoxElement size)
		].! !

!Box methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/14/2011 15:01'!
capacity: anInteger
	capacity := anInteger.! !

!Box methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/14/2011 15:00'!
initialize
	elements := OrderedCollection new.! !

!Box methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/14/2011 18:18'!
removeBiggestElement
	(elements isEmpty)
		ifTrue: [ EmptyBox signal: 'box is empty'. ]
		ifFalse: [
			| biggest biggestIndex |
			biggest := 0.
			biggestIndex := 0.
			elements do: [ :el |
				(el size > biggest)
					ifTrue: [
						biggest := el size.
						biggestIndex := elements indexOf: el.
					].
			].
			^ elements removeAtIndex: biggestIndex.
		].! !

Object subclass: #BoxElement
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BugFinderExample'!

!BoxElement methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/14/2011 15:03'!
size
	^ size.! !

!BoxElement methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/14/2011 15:03'!
size: anInteger
	size := anInteger.! !

Object subclass: #BugFinderExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BugFinderExample'!

!BugFinderExample methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/16/2011 17:05'!
fullBox
	| box |
	box := Box new
		capacity: 55;
		add: ( BoxElement new size: 3; yourself );
		add: ( BoxElement new size: 10; yourself );
		add: ( BoxElement new size: 4; yourself );
		add: ( BoxElement new size: 1; yourself );
		add: ( BoxElement new size: 2; yourself );
		add: ( BoxElement new size: 8; yourself );
		add: ( BoxElement new size: 7; yourself );
		add: ( BoxElement new size: 9; yourself );
		add: ( BoxElement new size: 6; yourself );
		add: ( BoxElement new size: 5; yourself );
		yourself.
	^ BugFinder new tryUnarySelectors: box.! !
